##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################
'''
Give Folders a Filter dropdown, allowing you to choose which
meta-types you see in both the object list and the add list.

$Id: __init__.py,v 1.1 2002/07/31 21:39:53 evan Exp $
'''

from Globals import DTMLFile
import FolderFilter, re
from urllib import quote

filter_list = DTMLFile('www/filter', globals())

def ff_picklist(self):
    ffh = getattr(self, 'Folder Filter Holder', 0)
    req = self.REQUEST
    if not ffh:
        return {}
    ffhpath='%s/%s/pick_filter' % (req['URL1'], quote(ffh.getId()))
    filter = ffh.get_filter()
    req.set('filter', filter)
    if filter:
        def yes(x): return 1
        fmt = []
        if filter.get('meta_types'):
            mtf = filter['meta_types'].get
        else:
            mtf = yes
        mtk = not not filter.get('mt_kind')
        for mt in self.filtered_meta_types():
            if mtk == (not mtf(mt['name'])):
                fmt.append(mt)
        oi = []
        if filter.get('ids'):
            idfilters = filter['ids']
            def_hide = not idfilters[0][0]
        else:
            idfilters = ()
            def_hide = 0
        all_oi = self.objectItems()
        for obitem in all_oi:
            if mtk == (not mtf(obitem[1].meta_type)):
                id = obitem[0]
                hide = def_hide
                for idkind, idstr in idfilters:
                    if idkind != hide and re.search(idstr, id):
                        hide = idkind
                if not hide:
                    oi.append(obitem)
        hidden = len(all_oi) - len(oi)
    else:
        fmt = self.filtered_meta_types()
        oi = self.objectItems()
        hidden = 0
    
    dropdown = filter_list.__of__(self)(
        self, req, ffh=ffh, ffhpath=ffhpath, filters=ffh.get_filters(),
        hide_count=hidden)

    return {'ff_dropdown': dropdown, 'filtered_meta_types': fmt,
            'objectItems': oi}

def initialize(context):
    from OFS.Folder import Folder
    Folder.manage_main = DTMLFile('www/main', globals())
    Folder.ff_picklist = ff_picklist
    context.registerClass(instance_class=FolderFilter.FolderFilterHolder,
                          permission='Add Folder Filter Holders',
                          constructors=FolderFilter.constructors,
                          icon='www/FolderFilter.gif')
